﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace RarMount2
{
    static class Subtitle
    {
        static string[] fileexts = { ".srt", ".sub", ".smi", ".ssa" };

        internal static string findSubtitle(string rarFileName, string storedFileName)
        {
            string[] folders = { "", "Sub", "subtitles" };
            FileInfo fi = new FileInfo(rarFileName);
            string filefolder = fi.DirectoryName;
            string[] filenames = new string[2];
            filenames[0] = getBaseFileName(fi.Name);
            filenames[1] = getBaseFileName(storedFileName);

            if (!fi.Exists)
            {
                return "";
            }

            string currfolder = "";
            foreach (string fold in folders)
            {
                currfolder = Path.Combine(filefolder, fold);
                foreach (string fn in filenames)
                {
                    foreach (string ext in fileexts)
                    {
                        if (File.Exists(currfolder + "\\" + fn + ext))
                            return fn + ext;
                    }
                }
            }

            return "";
        }

        internal static string getBaseFileName(string fileName)
        {
            if ((fileName.Length > 12 && fileName.ToLower().Substring(fileName.Length - 12, 12) == ".part001.rar") ||
                (fileName.Length > 11 && fileName.ToLower().Substring(fileName.Length - 11, 11) == ".part01.rar"))
            {
                return fileName.Substring(0, fileName.Length - 7);
            }
            else if (fileName.Length > 4 && fileName.ToLower().Substring(fileName.Length - 4, 1) == ".")
            {
                return fileName.Substring(0, fileName.Length - 4);
            }
            else
                return "";
        }

        internal static void removeOldSubtitles(string folder)
        {
            string filename = string.Empty;
            foreach (string ext in fileexts)
            {
                filename = Path.Combine(folder, String.Format("UNPACKED{0}", ext));
                if (File.Exists(filename))
                {
                    try
                    {
                        File.Delete(filename);
                    }
                    catch
                    {
                    }
                }
            }
        }
    }
}
